#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xlocale.h>

Display *d;      Window w;
GC gc;           XFontSet fs;
Atom prop;       Bool selected = False;
char txt[512];   int len = 0;
Atom a;
XTextProperty ct;

main()
{
   XEvent e;
   char **miss, *def;
   int n_miss;

   setlocale (LC_ALL, "");
   d = XOpenDisplay (NULL);

   fs = XCreateFontSet (d, "-*-*-*-*-*-*-18-*", &miss, &n_miss, &def);
   if (fs == NULL) fprintf (stderr, "Cannot create fontset\n");

   prop = XInternAtom (d, "__COPY_TEXT", False);
   a = XInternAtom (d, "COMPOUND_TEXT", False);

   w = XCreateSimpleWindow (d, RootWindow (d, 0), 400, 400, 400, 50,
                            2, BlackPixel (d, 0), WhitePixel (d, 0));
   XSelectInput (d, w, ButtonPressMask);
   XMapWindow (d, w);

   gc = XCreateGC (d, w, 0, 0);
   XSetForeground (d, gc, BlackPixel (d, 0));

   while (1)
     {
       XNextEvent (d, &e);
       switch (e.type)
         {
           case ButtonPress:
                  if (selected == False)
                    if (e.xbutton.button == Button1)
                      OwnSelection (e);
                    else if (e.xbutton.button == Button2)
                      RequestSelectionData (e);
                  break;
           case SelectionClear:
                  LoseSelection (e); break;
           case SelectionRequest:
                  StoreSelectionData (e); break;
           case SelectionNotify:
                  RetrieveSelectionData (e); break;
         }
     }
}

OwnSelection (e)
XEvent e;
{
   XSetSelectionOwner (d, XA_PRIMARY, w, e.xbutton.time);
   if (XGetSelectionOwner (d, XA_PRIMARY) == w)
     {
       XSetWindowBackground (d, w, BlackPixel (d, 0));
       XSetForeground (d, gc, WhitePixel (d, 0));
       XClearWindow (d, w);
       XmbDrawString (d, w, fs, gc, 30, 30, txt, len);
       selected = True;
     }
}

LoseSelection (e)
XEvent e;
{
  if (e.xselectionclear.window == w
      && e.xselection.selection == XA_PRIMARY)
    {
      XSetWindowBackground (d, w, WhitePixel (d, 0));
      XSetForeground (d, gc, BlackPixel (d, 0));
      XClearWindow (d, w);
      XmbDrawString (d, w, fs, gc, 30, 30, txt, len);
      selected = False;
    }
}

RequestSelectionData (e)
XEvent e;
{
   Atom tgt = XInternAtom (d, "TARGETS", False);

   XConvertSelection (d, XA_PRIMARY, tgt, prop, w, e.xbutton.time);
}

StoreSelectionData (e)
XEvent e;
{
   XSelectionEvent se;
   char *cl[4];
   Atom al[3];
   Atom tgt = XInternAtom (d, "TARGETS", False);

   al[0] = tgt;
   al[1] = a;
   al[2] = XA_STRING;

   cl[0] = txt;

   se.type = SelectionNotify;
   se.requestor = e.xselectionrequest.requestor;
   se.selection = e.xselectionrequest.selection;
   se.target = e.xselectionrequest.target;
   se.time = e.xselectionrequest.time;
   se.property = e.xselectionrequest.property;

   if (e.xselectionrequest.selection == XA_PRIMARY)
     {
       if (e.xselectionrequest.target == tgt)
         {
           XChangeProperty (d, se.requestor, se.property, XA_ATOM,
                            32, PropModeReplace, al, 3);
         }
       else if (e.xselectionrequest.target == a)
         {
           XmbTextListToTextProperty (d, cl, 1,
                                      XCompoundTextStyle, &ct);
           XChangeProperty (d, se.requestor, se.property, se.target,
                            8, PropModeReplace, ct.value, ct.nitems);
         }
       else if (e.xselectionrequest.target == XA_STRING)
         {
           XmbTextListToTextProperty (d, cl, 1, XStringStyle, &ct);
           XChangeProperty (d, se.requestor, se.property, se.target,
                            8, PropModeReplace, ct.value, ct.nitems);
         }
       else
         se.property = None;
     }
   else
     se.property = None;

   XSendEvent (d, se.requestor, False, NULL, &se);
}

RetrieveSelectionData (e)
XEvent e;
{
   Atom type;
   char *buff, **cl;
   int i, fmt;
   unsigned long nitems, left;
   Atom *al;
   Atom tgt = XInternAtom (d, "TARGETS", False);

   if (e.xselection.selection != XA_PRIMARY
       || e.xselection.property != prop)
     return;

   if (e.xselection.target == tgt)
     {
       if (XGetWindowProperty (d, w, prop, 0, 1024, False, XA_ATOM,
                               &type, &fmt, &nitems, &left, &al)
                        == Success && nitems > 0)
         for (i = 0; i < nitems; i++)
           if (al[i] == a || al[i] == XA_STRING)
             {
               XConvertSelection (d, XA_PRIMARY, al[i], prop, w,
                                  e.xselection.time);
               break;
             }
     }
   else if (e.xselection.target == a
            || e.xselection.target == XA_STRING)
     {
       if (XGetWindowProperty (d, w, prop, 0, 1024, False,
                               e.xselection.target,
                               &type, &fmt, &nitems, &left, &buff)
                        == Success && nitems > 0)
         {
           ct.value = buff;
           ct.encoding = e.xselection.target;
           ct.format = fmt;
           ct.nitems = nitems;
           XmbTextPropertyToTextList (d, &ct, &cl, &nitems);

           strcpy (txt, cl[0]);
           len = strlen (txt);
           XClearWindow (d, w);
           XmbDrawString (d, w, fs, gc, 30, 30, txt, len);
         }
     }
}
